#! /usr/bin/env python
###############################################################################
# parts.py                                                                    #
# Roger Whittaker                                                             #
# 20050504                                                                    #
# SUDOKU problem solver                                                       #
###############################################################################
# The python files required are:                                              #
#   parts.py                                                                  #
#   readfile.py                                                               #
#   solve.py                                                                  #
#   so.py                                                                     #
###############################################################################
# Copyright Roger Whittaker 2005                                              #
# This file may be freely used, modified and redistributed provided that this #
# copyright notice is retained                                                #
###############################################################################
# All cells                                                                   #
###############################################################################
A = [(i, j) for i in range(9)   \
     for  j in range(9)]
###############################################################################
# Rows                                                                        #
###############################################################################
R = [[(i, j) for j in range(9)] \
     for i in range(9)]
###############################################################################
# Columns                                                                     #
###############################################################################
C = [[(i, j) for i in range(9)] \
     for j in range(9)]
###############################################################################
# Blocks                                                                      #
###############################################################################
B = [[(i+3*p, j+3*q)     \
      for i in range(3)  \
      for j in range(3)] \
     for p in range(3)   \
     for q in range(3)]
###############################################################################
N = ['1', '2', '3', '4', '5', '6', '7', '8', '9']
###############################################################################
# Items - rows, columns and blocks together                                   #
###############################################################################
I = []
for i in R:
    I.append(i)
for i in C:
    I.append(i)
for i in B:
    I.append(i)
###############################################################################
def R2(item):
    X = [(p, q)                                        \
         for p in set(item)                            \
         for q in set(item) - set([p])]
    return set(X)
###############################################################################
def R3(item):
    X = [(p, q, r)                                     \
         for p in set(item)                            \
         for q in set(item) - set([p])                 \
         for r in set(item) - set([p, q])]
    return set(X)
###############################################################################
def R4(item):
    X = [(p, q, r, s)                                  \
         for p in set(item)                            \
         for q in set(item) - set([p])                 \
         for r in set(item) - set([p, q])              \
         for s in set(item) - set([p, q, r])]
    return set(X)
###############################################################################
def R5(item):
    X = [(p, q, r, s, t)                               \
         for p in set(item)                            \
         for q in set(item) - set([p])                 \
         for r in set(item) - set([p, q])              \
         for s in set(item) - set([p, q, r])           \
         for t in set(item) - set([p, q, r, s])]
    return set(X)
###############################################################################
def R6(item):
    X = [(p, q, r, s, t, u)                            \
         for p in set(item)                            \
         for q in set(item) - set([p])                 \
         for r in set(item) - set([p, q])              \
         for s in set(item) - set([p, q, r])           \
         for t in set(item) - set([p, q, r, s])        \
         for u in set(item) - set([p, q, r, s, t])
         ]
    return set(X)
###############################################################################
def R7(item):
    X = [(p, q, r, s, t, u, v)                         \
         for p in set(item)                            \
         for q in set(item) - set([p])                 \
         for r in set(item) - set([p, q])              \
         for s in set(item) - set([p, q, r])           \
         for t in set(item) - set([p, q, r, s])        \
         for u in set(item) - set([p, q, r, s, t])     \
         for v in set(item) - set([p, q, r, s, t, u])
         ]
    return set(X)
###############################################################################
def RR(n, item):
    if n==2:
        return R2(item)
    if n==3:
        return R3(item)
    if n==4:
        return R4(item)
    if n==5:
        return R5(item)
    if n==6:
        return R6(item)
    if n==7:
        return R7(item)
###############################################################################
if __name__=='__main__':
    print 'A = ', A
    print
    print 'R = ', R
    print
    print 'C = ', C
    print
    print 'B = ', B
    print
    print 'I = ', I
###############################################################################
