#! /usr/bin/env python
###############################################################################
# readfile.py                                                                 #
# Roger Whittaker                                                             #
# 20050504                                                                    #
# SUDOKU problem solver                                                       #
###############################################################################
# The python files required are:                                              #
#   parts.py                                                                  #
#   readfile.py                                                               #
#   solve.py                                                                  #
#   so.py                                                                     #
###############################################################################
# Copyright Roger Whittaker 2005                                              #
# This file may be freely used, modified and redistributed provided that this #
# copyright notice is retained                                                #
###############################################################################
from parts import A, B, C, R
###############################################################################
def readfile(arg):
    infile = open(arg, 'r')
    a = {}
    lines = infile.readlines()
    for i in range(9):
        if len(lines[i].split('|')) == 10:
            for j in range(9):
                a[(i,j)] = lines[i].strip().split('|')[j].strip()
    return a
###############################################################################
def display(dict):
    rule = '+---' *9 + '+' + '\n'
    out = rule
    for i in R:
        for j in i:
            out = out + '|' + dict[j].rjust(2) + ' '
        out = out + '|' + '\n'
        out = out + rule
    return out
###############################################################################
def writefile(dict):
    out = ''
    for i in R:
        for j in i:
            out = out + dict[j].rjust(1) + '|'
        out = out + '\n'
    return out
###############################################################################
if __name__=='__main__':
    print 'testing readfile.py'
    print
    print '    to solve problems run solve.py'
    print '    reading the sample file sudoku.100'
    print
    print display(readfile('sudoku.100'))
###############################################################################
