#! /usr/bin/env python
###############################################################################
# solve.py                                                                    #
# Roger Whittaker                                                             #
# 20050504                                                                    #
# SUDOKU problem solver                                                       #
###############################################################################
# The python files required are:                                              #
#   parts.py                                                                  #
#   readfile.py                                                               #
#   solve.py                                                                  #
#   so.py                                                                     #
###############################################################################
# Copyright Roger Whittaker 2005                                              #
# This file may be freely used, modified and redistributed provided that this #
# copyright notice is retained                                                #
###############################################################################
from sys       import argv, exit
###############################################################################
from readfile  import readfile, writefile
from so        import so
###############################################################################
def update(ob):
    new = so(ob.possible()[1])
    return new
###############################################################################
usage = 'Usage: '                                               + '\n' + \
        'python solve.py sudoku.file'                           + '\n' + \
        '  where sudoku.file is a sudoku puzzle in the format ' + '\n' + \
        '  of the example file sudoku.100 distributed with the program'
###############################################################################
try:
    o   = readfile(argv[1])
    out = open(argv[1] + '.out', 'w')
except:
    print usage
    exit()
###############################################################################
a = so(o)
###############################################################################
out.write('INPUT')
out.write('\n')
out.write(writefile(a))
out.write('\n')
###############################################################################
print ' ----------------------------------- '
print '          Solving this sudoku:'
print `a` 
print ' ' + '=' * 15 + ' ' + `a.known()` + ' ' + '=' * 15
print
print ' ----------------------------------- '
print ' ----------------------------------- '
print
###############################################################################
while 1:
    k = a.known()
    a = update(a)
    l = a.known()
    print `a`
    print ' ' + '=' * 15 + ' ' + `a.known()` + ' ' + '=' * 15
    print
    print
    if l == k:
        break
###############################################################################
out.write('OUTPUT')
out.write('\n')
out.write(writefile(a))
out.write('\n')
###############################################################################

